%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculates the combined B matrix for inverters - nonlinear
%
% @author Andrea Angioni <aangioni@eonerc.rwth-aachen.de>
% @copyright 2018, Institute for Automation of Complex Power Systems, EONERC
% @license GNU General Public License (version 3)
%
% Statespacemodeldistribution
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function BINV = def_BINV_NL(DM,SD,x)
% B matrix non-linear
ref = DM.ref;
Nnode = DM.Nnode;
Cf = DM.Cf(x);
wc = DM.wc(x);
delta = SD.delta(x);
V0D = SD.V0D(x);
V0Q = SD.V0Q(x);

BINV1 =([[ 0, 0,];...
    [  0, 0];...
    [ V0D*wc, V0Q*wc];...
    [ V0Q*wc, -V0D*wc];...
    [  0, 0];...
    [  0, 0];...
    [  0, 0];...
    [  0, 0];...
    [  0, 0];...
    [  0, 0];...
    [ -cos(delta)/Cf, sin(delta)/Cf];...
    [ -sin(delta)/Cf, -cos(delta)/Cf]]);
BINV = zeros(12,2*Nnode);
BINV(:,2*(x-1)+1:2*x) = BINV1;
if x == ref
    BINV1 =([[0, 0];...
        [V0D*wc, V0Q*wc];...
        [V0Q*wc, -V0D*wc];...
        [0, 0];...
        [0, 0];...
        [0, 0];...
        [0, 0];...
        [0, 0];...
        [0, 0];...
        [-1/Cf, 0];...
        [0, -1/Cf]]);
    BINV = zeros(11,2*Nnode);
    BINV(:,2*(x-1)+1:2*x) = BINV1;
end

end